Note: This is a beta release of Red Hat Bugzilla 5.0. The data contained within is a snapshot of the live data so any changes you make will not be reflected in the production Bugzilla. Also email is disabled so feel free to test any aspect of the site that you want. File any problems you find or give feedback here.
Bug 161188 - Sometimes data/bss can be executable
Summary: Sometimes data/bss can be executable
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Red Hat Enterprise Linux 3
Classification: Red Hat
Component: kernel
Version: 3.0
Hardware: All
OS: Linux
medium
high
Target Milestone: ---
Assignee: Ingo Molnar
QA Contact: Brian Brock
URL:
Whiteboard: embargo=self,source=redhat,impact=imp...
Depends On:
Blocks: 168424
TreeView+ depends on / blocked
 
Reported: 2005-06-21 07:53 UTC by Mark J. Cox
Modified: 2007-11-30 22:07 UTC (History)
5 users (show)

Fixed In Version: RHSA-2006-0144
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2006-03-15 16:08:06 UTC


Attachments (Terms of Use)


Links
System ID Priority Status Summary Last Updated
Red Hat Product Errata RHSA-2006:0144 qe-ready SHIPPED_LIVE Moderate: Updated kernel packages available for Red Hat Enterprise Linux 3 Update 7 2006-03-15 05:00:00 UTC

Description Mark J. Cox 2005-06-21 07:53:03 UTC
The execshield code in RHEL3 is pretty similar so this probably applies to RHEL3
as well; if so this is a serious issue (see #161136) 

+++ This bug was initially created as a clone of Bug #161136 +++

Whilst playing with an X application I found that around 20% of the time
libraries would get loaded between bss and brk, therefore making the
applications bss and data executable.  Ingo discovered it was due to an
execshield bug:

"this patch fixes the fallback randomizer to randomize between 
16MB...start_brk, instead of 16MB...brk. ->brk is problematic because 
due to brk randomization it creates a hole between BSS and brk, where 
DSOs might be loaded randomly." "i have tested the patch against the exec-shield
patch(es) in Fedora, so it would be safe to apply. PIEs work fine and the 
randomization now works correctly."

Comment 5 Ernie Petrides 2005-09-30 06:44:51 UTC
A fix for this problem has just been committed to the RHEL3 U7
patch pool this evening (in kernel version 2.4.21-37.4.EL).


Comment 8 Red Hat Bugzilla 2006-03-15 16:08:06 UTC
An advisory has been issued which should help the problem
described in this bug report. This report is therefore being
closed with a resolution of ERRATA. For more information
on the solution and/or where to find the updated files,
please follow the link below. You may reopen this bug report
if the solution does not work for you.

http://rhn.redhat.com/errata/RHSA-2006-0144.html



Note You need to log in before you can comment on or make changes to this bug.